<template>
  <div class="content">
    <div class="list-of-lists position-absolute d-flex">
      <card-list v-for="(list, index) in lists" :key="index" :list="list" />
      <div>
        <card-list-add-button @click="handleOpenCreateList" />
      </div>
    </div>
    <card-list-create-form
      :board="board"
      :open="openCreateForm"
      @create="handleCreateList"
      @cancel="handleCloseCreateList"
      @close="handleCloseCreateList"
    />
  </div>
</template>

<script lang="ts">
import CardList from "@/components/CardList.vue";
import CardListAddButton from "@/components/CardListAddButton.vue";
import CardListCreateForm from "@/components/CardListCreateForm.vue";
import { Board, List, LocalDatabase } from "@/core/database";
import { BoardRepository } from "@/core/repositories";
import { ListRepository } from "@/core/repositories/list-repository";
import { SubSink } from "subsink";
import { defineComponent } from "vue";

export default defineComponent({
  components: { CardList, CardListAddButton, CardListCreateForm },
  created() {
    LocalDatabase.getInstance().then(async (db) => {
      this.listRepository = ListRepository.getInstance(db);
      this.boardRepository = BoardRepository.getInstance(db);
      const board = await this.boardRepository.getItem(this.boardId);
      const listObservable = await this.listRepository.watchAllItems(
        "boardId",
        this.boardId
      );
      if (board) {
        this.board = board;
      }
      this.subSink.sink = listObservable.subscribe((lists) => {
        if (lists) {
          this.lists = lists;
        }
      });
    });
  },
  props: {
    boardId: {
      type: String,
      required: true,
    },
  },
  data() {
    return {
      board: {} as Board,
      boardRepository: {} as BoardRepository,
      listRepository: {} as ListRepository,
      lists: [] as List[],
      openCreateForm: false,
      subSink: new SubSink(),
    };
  },
  methods: {
    async handleCreateList(newList: List) {
      try {
        await this.listRepository.insertItem(newList);
      } catch (error) {
        console.log(error);
      }
    },
    handleCloseCreateList() {
      this.openCreateForm = false;
    },
    handleOpenCreateList() {
      this.openCreateForm = true;
    },
  },
  unmounted() {
    this.subSink.unsubscribe();
  },
});
</script>

<style scoped>
.content {
  width: 100%;
  max-width: 100%;
  margin-top: 2rem;
  margin-left: 1rem;
  position: relative;
  height: 100%;
}

.list-of-lists {
  top: 0;
  bottom: 0;
  left: 0;
  right: 0;
  overflow-x: auto;
  overflow-y: hidden;
}

.list-of-lists > * {
  margin-left: 1.875rem;
  margin-right: 1.875rem;
}

.list-of-lists > *:first-child {
  margin-left: 0;
}

@media (min-width: 768px) {
  .content {
    margin-top: 3rem;
  }
}

@media (min-width: 992px) {
  .content {
    margin-left: 3rem;
  }
}
</style>
